#include "scene.h"
#include "V3.h"
#include "m33.h"

Scene *scene;

using namespace std;

#include <iostream>
#include <fstream>
#include <strstream>

Scene::Scene() {


	int u0 = 20;
	int v0 = 40;
	int h = 400;
	int w = 600;
	fb = new FrameBuffer(u0, v0, w, h);
	fb->position(u0, v0);
	fb->label("SW Framebuffer");
	fb->show();
	fb->redraw();

	gui = new GUI();
	gui->show();
	gui->uiw->position(u0, v0 + fb->h + v0);


}


void Scene::DBG() {
	cerr << endl;

	{
		int fN = 1000;
		V3 p0(20.0f, 30.3f, 0.0f);
		V3 p1(220.0f, 130.3f, 0.0f);
		for (int fi = 0; fi < fN; fi++) {
			fb->Set(0xFFDDDDDD);
			fb->Rasterize2DSegment(p0, p1, 0xFF0000FF);
			fb->redraw();
			Fl::check();
			p0 = p0 + V3(0.0f, +1.0f, 0.0f);
			p1 = p1 + V3(0.0f, -1.0f, 0.0f);
		}
		return;
	}
	{
		V3 center(100.3f, 200.9f, 0.0f);
		float radius = 34.1f;
		fb->Set(0xFFFFFFFF);
		fb->RasterizeCircle(center, radius, 0xFF000000);
		fb->redraw();
		return;
	}


	{
		int u0 = 30;
		int v0 = 50;
		int l = 100;
		int h = 200;
		int fN = 600;
		for (int fi = 0; fi < fN; fi++) {
			fb->Set(0xFFFFFFFF);
			unsigned int col = 0xFF00FF00;
			fb->RasterizeRectangle(u0, v0, l, h, col);
			fb->redraw();
			Fl::check();
			u0++;
		}
		return;
	}
	{
		M33 m;
		m[0] = V3(1.0f, 0.0f, 0.0f);
		m[1] = V3(0.0f, 1.0f, 0.0f);
		m[2] = V3(1.0f, 0.0f, 1.0f);
		cerr << m << endl;
		cerr << m.GetColumn(0);
		return;
		V3 v(10.0f, 9.0f, 3.0f);
		cerr << m*v << endl;
		return;
		cerr << "row 0: " << m[1] << endl;
		return;
	}
	{
		V3 v0(1.0f, 2.0f, 3.0f);
		cerr << endl << "v0: " << v0;
		return;
	}

	{
		V3 v0(1.0f, 2.0f, 3.0f);
		cerr << endl << v0[0] << " " << v0[1] << endl;
		v0[1] = 100.0f;
		return;
		V3 v1(2.0f, 2.0f, 2.0f);
		// v0[0]
		V3 v2 = v0 + v1;
		cerr << v2.xyz[0] << endl;
		return;
	}

	{
		cerr << "INFO: pressed DBG" << endl;
		fb->Set(0xFF0000FF);
		fb->redraw();
	}
}

void Scene::NewButton() {
	cerr << "INFO: pressed New button on GUI" << endl;
}




